#include "mbed.h"

int dobaLokalizacniSekvence = 500;

I2CSlave slave(D4, D5); //SDA, SCK
Serial pc(USBTX, USBRX);
Timer timer;

//LED
DigitalOut redLED(A2);
DigitalOut blueLED(A1);
DigitalOut greenLED(A0);

bool inProgress = false;

int main() {
    //SPI setup
    slave.frequency(100000);
    slave.address(0xA0);
    
    char buf[1];
    
    for(int i = 0; i < 3; i++) {
        redLED = 1;
        wait(0.1);
        redLED = 0;
        wait(0.1);
    }
    
    while (1) {
         if(inProgress && timer.read_ms() > dobaLokalizacniSekvence)
         {
             inProgress = false;
             timer.stop();
             timer.reset();
             blueLED = 0;
         }
         
         int i = slave.receive();
         switch (i) {
             case I2CSlave::ReadAddressed:
                if(!inProgress)
                {
                    slave.write("y", 1);
                }
                else
                {
                    slave.write("n", 1);
                }
                 break;
             case I2CSlave::WriteAddressed:
                 slave.read(buf, 1);
                 if(buf[0] == 'y')
                 {
                     timer.start();
                     inProgress = true;
                     blueLED = 1;
                 }
                 break;
         }
         buf[0] = 0;    // Clear buffer
         if(!inProgress)
         {
            sleep();
         }
     }
}
