#include "mbed.h"
#include "func.h"
#include <vector>

int dobaLokalizacniSekvence = 500;

//IQRF
SPI spi(D11, D12, D13); // mosi, miso, sclk
DigitalOut slave(A3);
InterruptIn iqrfInterrupt(D7);

Serial pc(USBTX, USBRX);
Timer timer;

//LED
DigitalOut redLED(A2);
DigitalOut blueLED(A1);
DigitalOut greenLED(A0);

//ID teto slave veze
char IDSlave = '0';
//ID mastera
char IDMaster = '0';

void iqrfHasData()
{
    //pc.printf("\n\rprijem\n\r");
}


int main()
{
    //SPI setup
    slave = 1;
    wait(0.1);
    spi.format(8,0);        // Setup:  8bitu, pol = 0, pha = 0 -> rising edge, idle low
    spi.frequency(100000);  //Hz
    
    //IQRF modul init
    vector<char> init;
    init.push_back('I');
    init.push_back('N');
    init.push_back('I');
    init.push_back('T');
    init.push_back('S');
    init.push_back(IDSlave);
    sendData(init, slave, spi);
    
    bool inProgress = false;

    for(int i = 0; i < 3; i++) {
        redLED = 1;
        wait(0.1);
        redLED = 0;
        wait(0.1);
    }
    
    while (1) {
        if(inProgress && timer.read_ms() > dobaLokalizacniSekvence) 
        {
            inProgress = false;
            timer.stop();
            timer.reset();
            blueLED = 0;
        }
        
        //dotaz na status IQRF modulu
        char SPI_status = checkSPIStatus(slave, spi);
        SPI_status = checkSPIStatus(slave, spi);

        if(SPI_status >= 64 && SPI_status <= 127) {
            //prectu data z IQRF modulu
            vector<char> response = readData(SPI_status, slave, spi);

            if(response.at(0)=='M' && response.at(1)==IDMaster && response.at(2)=='S' && response.at(3)==IDSlave) {
                if(response.at(4) == 'Y')
                {
                    if(!inProgress) {
                        
                        timer.start();
                        inProgress = true;
                        blueLED = 1;
                    }
                    vector<char> data;
                    //kdo a komu
                    data.push_back('S');
                    data.push_back(IDSlave);
                    data.push_back('M');
                    data.push_back(IDMaster);
                    data.push_back('K');
                    //poslu do IQRF modulu
                    sendData(data, slave, spi);
                }
                if(response.at(4) == 'H')
                {
                    vector<char> data;
                    //kdo a komu
                    data.push_back('S');
                    data.push_back(IDSlave);
                    data.push_back('M');
                    data.push_back(IDMaster);
    
                    if(!inProgress) {
                        data.push_back('Y');
                        //poslu do IQRF modulu
                        sendData(data, slave, spi);
                        
                    } else {
                        data.push_back('K');
                        //poslu do IQRF modulu
                        sendData(data, slave, spi);
                    }
                }
            }
        }
        if(!inProgress)
         {
            sleep();
         }
    }
}
