#include "template-basic.h"	// System header files

#define	RX_FILTER				0			//0 - 100, 0 maximalni dosah

void APPLICATION()
{
	setRFpower(7);							//Set RF output power uns8 level: 0 (min.) to 7 (max. – default)
	//setRFspeed(speed);					//NOT IMPLEMENTED Bit rate 19.836 kb/s is fixed.
	//setRFband(1);							//Select RF frequency band uns8 band: 0 -> 868 band MHz (default), 1 -> 916 band MHz
	//setRFchannel(channel);				//Set RF channel: 868 MHz band: 52 default
	enableSPI();                    		//Enable SPI
	setRFmode(_WPE | _RX_STD | _TX_STD);	//SWTTFFRR in binary, Default value is mode = 0
	//SWDTEN = 0; 							// Possibly disable WDT for lower consumption
	toutRF = 1;                     		// Wait Packed End active so the toutRF can be set to minimum
	TRISA.0 = 0;							//IO1 C1 je vystupni pin
	
	char myType;
	char myId;
	
    while (1)
    {
		clrwdt();
		if (checkRF(RX_FILTER))		// RF signal detection (takes cca 1ms)
		{
			if (RFRXpacket())           // If anything was received
			{
				if((bufferRF[0] == 0x4D && bufferRF[2] == myType && bufferRF[3] == 0x58) 							//robot je hledan masterem
				 ||(bufferRF[0] == 0x52 && bufferRF[2] == myType && bufferRF[3] == myId && bufferRF[4] == 0x4F))	//master prijima odpoved na hledani robotu
				{
					pulseLEDG();            //   LED indication
					copyBufferRF2COM();     //   Copy received RF from bufferRF to bufferCOM
					startSPI(DLEN);         //   send it via SPI
					
					LATA.0 = 1;				//zapis log. 1 na IO1 C1
					waitDelay(1);
					LATA.0 = 0;				//zapis log. 0 na IO1 C1
				}
				else if(bufferRF[2] == myType && bufferRF[3] == myId)	//prijata normalni zprava
				{
					char fromType = bufferRF[0];
					char fromId = bufferRF[1];
					
					pulseLEDG();            //   LED indication
					copyBufferRF2COM();     //   Copy received RF from bufferRF to bufferCOM
					startSPI(DLEN);         //   send it via SPI
					
					LATA.0 = 1;				//zapis log. 1 na IO1 C1
					waitDelay(1);
					LATA.0 = 0;				//zapis log. 0 na IO1 C1
					
					//ack
					clearBufferRF();
					bufferRF[0] = myType;
					bufferRF[1] = myId;
					bufferRF[2] = fromType;
					bufferRF[3] = fromId;
					bufferRF[4] = 0x4b;
					PIN = 0;
					RFTXpacket();
				}
			} 
		}
		
		if (getStatusSPI())         // Update SPIstatus, check SPI busy
		{
            continue;               // Wait until message is picked up
		}
			
		if (_SPIRX)                 // Anything through SPI received?
        {                           
            if (_SPICRCok)          //  CRCM matched?
			{
				if(bufferCOM[0] == 0x49 && bufferCOM[1] == 0x4E && bufferCOM[2] == 0x49 && bufferCOM[3] == 0x54)	//INIT
				{
					myType = bufferCOM[4];
					myId = bufferCOM[5];
				}
				else	//Poslat zpravu
				{
					if((bufferCOM[0] == 0x4D && bufferCOM[2] == 0x52 && bufferCOM[3] == 0x58)		//master hleda dostupne roboty
					 ||(bufferCOM[0] == 0x52 && bufferCOM[2] == 0x4D && bufferCOM[4] == 0x4F))	//robot odpovida na hledani robotu masterovi
					{
						DLEN = SPIpacketLength;
						copyBufferCOM2RF();
						PIN = 0;
						RFTXpacket();
						pulseLEDR();
					}
					else	//odeslani normalni zpravy
					{
						int repeat = 0;
						bit ackPrijato = 0;
						while(repeat < 2)
						{
							DLEN = SPIpacketLength;
							copyBufferCOM2RF();	// Copy received SPI data from bufferCOM to bufferRF
							PIN = 0;
							RFTXpacket();
							pulseLEDR();		// LED indication
							
							startDelay(5);		//cekam na ack max 50ms
							
							//TODO: cekat na ack, jinak poslat znovu
							while(isDelay() && ackPrijato == 0)
							{
								clrwdt();
								if (checkRF(RX_FILTER))		// RF signal detection (takes cca 1ms)
								{
									if (RFRXpacket())           // If anything was received
									{
										if(bufferRF[2] == myType && bufferRF[3] == myId && bufferRF[4] == 0x4b)
										{
											ackPrijato = 1;
										}
									} 
								}
							}
							if(ackPrijato == 1)
							//ack prijato
							{
								repeat = 3;
							}
							else
							{
								repeat++;
							}
						}
						//ack neprijato
						if(ackPrijato == 0)
						{
							//poslat mbed neuspesny prenos
							bufferCOM[0] = bufferCOM[2];
							bufferCOM[1] = bufferCOM[3];
							bufferCOM[2] = myType;
							bufferCOM[3] = myId;
							bufferCOM[4] = 'N';
							startSPI(5);         	//send it via SPI
						
							LATA.0 = 1;				//zapis log. 1 na IO1 C1
							waitDelay(1);
							LATA.0 = 0;				//zapis log. 0 na IO1 C1
						}
						else						//poslu mbed desce potvrzeni
						{
							//poslat mbed uspesny prenos
							bufferCOM[0] = bufferCOM[2];
							bufferCOM[1] = bufferCOM[3];
							bufferCOM[2] = myType;
							bufferCOM[3] = myId;
							bufferCOM[4] = 'O';
							startSPI(5);         	//send it via SPI
						
							LATA.0 = 1;				//zapis log. 1 na IO1 C1
							waitDelay(1);
							LATA.0 = 0;				//zapis log. 0 na IO1 C1		
							
						}
					}
				}
				startSPI(0);            // Restart SPI communication
			}
			
		}
    }
}